/*********************************************************************
 *
 * HHS4HDUS.C
 *
 **********************************************************************/


/*
 *
 */
#include <WINDOWS.H>
#include "COMMON.C"
#include "LOG.C"
#include "HDUS.C"


/*--------------------------------------------------------------------
 * 萔̒`
 *--------------------------------------------------------------------*/


/*
 *
 */
#include "NNS4HDUS.H"


/*
 *
 */
#define MAX_UNIT_COUNT    10


/*--------------------------------------------------------------------
 * ̃O[oϐ
 *--------------------------------------------------------------------*/


/*
 *
 */
HINSTANCE RESOURCE;
char      TITLE[1024];


/*--------------------------------------------------------------------
 * O[oϐ̒`
 *--------------------------------------------------------------------*/


/*
 *
 */
DWORD  gRecord;                         /* ^s̈Č邩ǂ */
HANDLE gDevice[MAX_UNIT_COUNT];         /* ^sHDUSfoCX */
char   gFileName[MAX_UNIT_COUNT][512];  /* ^s̃t@C */
long   gAlarmFrac;                      /* A[̒[ */
long   gAlarmTime;                      /* A[ */
long   gStopFrac[MAX_UNIT_COUNT];       /* ~̒[ */
long   gStopTime[MAX_UNIT_COUNT];       /* ~ */


/*--------------------------------------------------------------------
 * ֐̒`(C_CAO)
 *--------------------------------------------------------------------*/


/*
 * ݒ̃[h
 */
void MAIN_LoadINI(HWND hWnd)
{
    HANDLE hFile;
    HWND   hItem;
    char   szText[1024];

    hItem = GetDlgItem(hWnd, ID_LIST_SCHEDULE);
    GetInitFileName(szText, sizeof(szText));
    hFile = OpenFileR(szText);
    while (ReadFileLine(hFile, szText, sizeof(szText))) {
        SendMessage(hItem, LB_ADDSTRING, 0, (LPARAM) szText);
    }
    CloseHandle(hFile);
}


/*
 * ݒ̃Z[u
 */
void MAIN_SaveINI(HWND hWnd)
{
    HANDLE hFile;
    HWND   hItem;
    char   szText[1024];
    long   nCount;
    long   nIndex;

    hItem = GetDlgItem(hWnd, ID_LIST_SCHEDULE);
    GetInitFileName(szText, sizeof(szText));
    hFile  = OpenFileW(szText);
    nCount = SendMessage(hItem, LB_GETCOUNT, 0, 0);
    for (nIndex = 0; nIndex < nCount; nIndex++) {
        SendMessage(hItem, LB_GETTEXT, nIndex, (LPARAM) szText);
        WriteFileText(hFile, szText);
        WriteFileText(hFile, "\r\n");
    }
    CloseHandle(hFile);
}


/*
 * O̕\
 */
void MAIN_Log(HWND hWnd, char *lpText)
{
    SYSTEMTIME st;
    char       szText[0x8000];

    GetLocalTime(&st);
    wsprintf(szText, "%d/%02d/%02d %02d:%02d:%02d %s\r\n", st.wYear, st.wMonth, st.wDay, st.wHour, st.wMinute, st.wSecond, lpText);
    PrintLog0(szText);
    lpText = szText;
    while (*lpText) {
        lpText++;
    }
    GetDlgItemText(hWnd, ID_EDIT_LOG, lpText, sizeof(szText) - (lpText - szText) - 1);
    SetDlgItemText(hWnd, ID_EDIT_LOG, szText);
}


/*
 * A[̍XV
 */
#define MAIN_Alarm_BANK(index, name)      \
    {                                     \
        StrCell(szText, (index), szWork); \
        (name) = DecToInt(szWork);        \
    }
void MAIN_Alarm(HWND hWnd)
{
    HWND hItem;
    char szText[1024];
    char szWork[1024];
    long nCount;
    long nIndex;
    long wDay;
    long wHour;
    long wMonth;
    long wYear;
    long xFrac;
    long xTime;
    long yFrac;
    long yTime;

    xTime = 0x7FFFFFFF;
    xFrac = 0x7FFFFFFF;
    /* Jn̍łÂ̂ */
    hItem  = GetDlgItem(hWnd, ID_LIST_SCHEDULE);
    nCount = SendMessage(hItem, LB_GETCOUNT, 0, 0);
    for (nIndex = 0; nIndex < nCount; nIndex++) {
        SendMessage(hItem, LB_GETTEXT, (WPARAM) nIndex, (LPARAM) szText);
        MAIN_Alarm_BANK(0, wYear);
        MAIN_Alarm_BANK(1, wMonth);
        MAIN_Alarm_BANK(2, wDay);
        MAIN_Alarm_BANK(3, wHour);
        MAIN_Alarm_BANK(4, yTime);
        MAIN_Alarm_BANK(5, yFrac);
        wMonth += wYear * 12;
        wDay   += wMonth * 31;
        wHour  += wDay * 24;
        yTime  += wHour * 60;
        if ((xTime > yTime) || ((xTime == yTime) && (xFrac > yFrac))) {
            xTime = yTime;
            xFrac = yFrac;
        }
    }
    /* ~̍łÂ̂ */
    if (gRecord) {
        for (nIndex = 0; nIndex < MAX_UNIT_COUNT; nIndex++) {
            if (gDevice[nIndex]) {
                yTime = gStopTime[nIndex];
                yFrac = gStopFrac[nIndex];
                if ((xTime > yTime) || ((xTime == yTime) && (xFrac > yFrac))) {
                    xTime = yTime;
                    xFrac = yFrac;
                }
            }
        }
    }
    gAlarmTime = xTime;
    gAlarmFrac = xFrac;
}


/*
 * XV
 */
#define MAIN_Update_BANK(index, name)     \
    {                                     \
        StrCell(szText, (index), szWork); \
        (name) = DecToInt(szWork);        \
    }
void MAIN_Update(HWND hWnd)
{
    BOOL       bCable;
    HWND       hItem;
    SYSTEMTIME st;
    char       *lpText;
    char       szFormat[1024];
    char       szText[1024];
    char       szWork[1024];
    long       nChan;
    long       nCount;
    long       nIndex;
    long       wDay;
    long       wHour;
    long       wMonth;
    long       wYear;
    long       xFrac;
    long       xTime;
    long       yFrac;
    long       yTime;

    /* ݎ̎擾 */
    GetLocalTime(&st);
    wYear   = st.wYear;
    wMonth  = st.wMonth;
    wDay    = st.wDay;
    wHour   = st.wHour;
    xTime   = st.wMinute;
    xFrac   = st.wSecond;
    wMonth += wYear * 12;
    wDay   += wMonth * 31;
    wHour  += wDay * 24;
    xTime  += wHour * 60;
    /* ~ */
    if (gRecord) {
        for (nIndex = 0; nIndex < MAX_UNIT_COUNT; nIndex++) {
            if (gDevice[nIndex]) {
                yTime = gStopTime[nIndex];
                yFrac = gStopFrac[nIndex];
                if ((xTime > yTime) || ((xTime == yTime) && (xFrac >= yFrac))) {
                    HDUS_Close(gDevice[nIndex]);
                    HDUS_Delete(gDevice[nIndex]);
                    gDevice[nIndex] = 0;
                    LoadString(RESOURCE, ID_STR_STOP_TASK_SUCCESS, szFormat, sizeof(szFormat));
                    wsprintf(szText, szFormat, gFileName[nIndex]);
                    MAIN_Log(hWnd, szText);
                }
            }
        }
        gRecord = 0;
        for (nIndex = 0; nIndex < MAX_UNIT_COUNT; nIndex++) {
            gRecord |= (DWORD) gDevice[nIndex];
        }
    }
    /* Jn */
    hItem  = GetDlgItem(hWnd, ID_LIST_SCHEDULE);
    nCount = SendMessage(hItem, LB_GETCOUNT, 0, 0);
    for (; nCount > 0; nCount--) {
        SendMessage(hItem, LB_GETTEXT, (WPARAM) nCount - 1, (LPARAM) szText);
        /* Jn̎擾 */
        MAIN_Update_BANK(0, wYear);
        MAIN_Update_BANK(1, wMonth);
        MAIN_Update_BANK(2, wDay);
        MAIN_Update_BANK(3, wHour);
        MAIN_Update_BANK(4, yTime);
        MAIN_Update_BANK(5, yFrac);
        wMonth += wYear * 12;
        wDay   += wMonth * 31;
        wHour  += wDay * 24;
        yTime  += wHour * 60;
        if ((xTime > yTime) || ((xTime == yTime) && (xFrac >= yFrac))) {
            SendMessage(hItem, LB_DELETESTRING, (WPARAM) nCount - 1, 0);
            /* 󂢂ĂfoCX̌ */
            for (nIndex = 0; nIndex < MAX_UNIT_COUNT; nIndex++) {
                if (gDevice[nIndex] == 0) {
                    break;
                }
            }
            if (nIndex >= MAX_UNIT_COUNT) {
                LoadString(RESOURCE, ID_STR_TOO_MANY_TASK, szText, sizeof(szText));
                MAIN_Log(hWnd, szText);
                return;
            }
            /* I̎擾 */
            MAIN_Update_BANK(6, wYear);
            MAIN_Update_BANK(7, wMonth);
            MAIN_Update_BANK(8, wDay);
            MAIN_Update_BANK(9, wHour);
            MAIN_Update_BANK(10, yTime);
            MAIN_Update_BANK(11, yFrac);
            wMonth += wYear * 12;
            wDay   += wMonth * 31;
            wHour  += wDay * 24;
            yTime  += wHour * 60;
            /* I̐ݒ */
            gStopTime[nIndex] = yTime;
            gStopFrac[nIndex] = yFrac;
            /* `l̐ݒ */
            StrCell(szText, 12, szWork);
            lpText = szWork;
            while (*lpText) {
                if (*lpText == '@') {
                    lpText++;
                    break;
                }
                lpText = CharNext(lpText);
            }
            bCable = FALSE;
            if (*lpText == 'C') {
                bCable = TRUE;
                lpText++;
            }
            nChan = DecToInt(lpText);
            /* t@C̐ݒ */
            StrCell(szText, 13, szWork);
            if (szWork[0] == 0) {
                StrCpy(szWork, szText);
                lpText = szWork;
                while (*lpText) {
                    if (*lpText == '\t') {
                        *lpText = '_';
                    }
                    lpText++;
                }
                lpText[0] = '.';
                lpText[1] = 't';
                lpText[2] = 's';
                lpText[3] = '2';
                lpText[4] = 0;
            }
            StrCpy(gFileName[nIndex], szWork);
            /* s */
            if ((gDevice[nIndex] = HDUS_Create()) == 0) {
                LoadString(RESOURCE, ID_STR_NOT_FOUND, szText, sizeof(szText));
            }
            else if (HDUS_Open(gDevice[nIndex], gFileName[nIndex], nChan, bCable) == FALSE) {
                LoadString(RESOURCE, ID_STR_START_TASK_ERROR, szFormat, sizeof(szFormat));
                wsprintf(szText, szFormat, gFileName[nIndex]);
            }
            else {
                LoadString(RESOURCE, ID_STR_START_TASK_SUCCESS, szFormat, sizeof(szFormat));
                wsprintf(szText, szFormat, gFileName[nIndex]);
                gRecord |= (DWORD) gDevice[nIndex];
            }
            MAIN_Log(hWnd, szText);
        }
    }
    /* Dx */
    MAIN_Alarm(hWnd);
    MAIN_SaveINI(hWnd);
}


/*
 * Q
 */
void MAIN_Refer(HWND hWnd)
{
    OPENFILENAME ofn;
    char         szDefExt[32] = "";
    char         szFileName[512];
    char         szFilter[512];

    szFileName[0] = 0;
    LoadString(RESOURCE, ID_STR_FILTER, szFilter, sizeof(szFilter));
    ZeroMemory(&ofn, sizeof(OPENFILENAME));
    ofn.lStructSize = 76; /* OPENFILENAME_SIZE_VERSION_400 */
    ofn.hwndOwner   = hWnd;
    ofn.lpstrFile   = szFileName;
    ofn.nMaxFile    = sizeof(szFileName);
    ofn.lpstrFilter = szFilter;
    ofn.lpstrDefExt = szDefExt;
    if (GetOpenFileName(&ofn)) {
        SetDlgItemText(hWnd, ID_EDIT_FILENAME, szFileName);
    }
}


/*
 * ǉ
 */
#define MAIN_Add_BANK(id)                                   \
    {                                                       \
        GetDlgItemText(hWnd, (id), szWork, sizeof(szWork)); \
        lpText    = StrCpy(lpText, szWork);                 \
        *lpText++ = '\t';                                   \
    }
void MAIN_Add(HWND hWnd)
{
    char *lpText;
    char szText[1024];
    char szWork[512];

    lpText = szText;
    MAIN_Add_BANK(ID_COMBO_START_YEAR);
    MAIN_Add_BANK(ID_COMBO_START_MONTH);
    MAIN_Add_BANK(ID_COMBO_START_DAY);
    MAIN_Add_BANK(ID_COMBO_START_HOUR);
    MAIN_Add_BANK(ID_COMBO_START_MINUTE);
    MAIN_Add_BANK(ID_COMBO_START_SECOND);
    MAIN_Add_BANK(ID_COMBO_STOP_YEAR);
    MAIN_Add_BANK(ID_COMBO_STOP_MONTH);
    MAIN_Add_BANK(ID_COMBO_STOP_DAY);
    MAIN_Add_BANK(ID_COMBO_STOP_HOUR);
    MAIN_Add_BANK(ID_COMBO_STOP_MINUTE);
    MAIN_Add_BANK(ID_COMBO_STOP_SECOND);
    MAIN_Add_BANK(ID_COMBO_CHANNEL);
    MAIN_Add_BANK(ID_EDIT_FILENAME);
    *(lpText - 1) = 0;
    SendMessage(GetDlgItem(hWnd, ID_LIST_SCHEDULE), LB_ADDSTRING, 0, (LPARAM) szText);
    MAIN_Alarm(hWnd);
    MAIN_SaveINI(hWnd);
}


/*
 * 폜
 */
void MAIN_Delete(HWND hWnd)
{
    HWND hItem;
    long nIndex;

    hItem  = GetDlgItem(hWnd, ID_LIST_SCHEDULE);
    nIndex = SendMessage(hItem, LB_GETCURSEL, 0, 0);
    SendMessage(hItem, LB_DELETESTRING, (WPARAM) nIndex, 0);
    MAIN_SaveINI(hWnd);
}


/*
 * IύX
 */
#define MAIN_SelChange_BANK(index, id)      \
    {                                       \
        StrCell(szText, (index), szWork);   \
        SetDlgItemText(hWnd, (id), szWork); \
    }
void MAIN_SelChange(HWND hWnd, long nId)
{
    HWND hItem;
    char szText[1024];
    char szWork[1024];
    long nIndex;

    hItem  = GetDlgItem(hWnd, ID_LIST_SCHEDULE);
    nIndex = SendMessage(hItem, LB_GETCURSEL, 0, 0);
    SendMessage(hItem, LB_GETTEXT, nIndex, (LPARAM) szText);
    MAIN_SelChange_BANK(0, ID_COMBO_START_YEAR);
    MAIN_SelChange_BANK(1, ID_COMBO_START_MONTH);
    MAIN_SelChange_BANK(2, ID_COMBO_START_DAY);
    MAIN_SelChange_BANK(3, ID_COMBO_START_HOUR);
    MAIN_SelChange_BANK(4, ID_COMBO_START_MINUTE);
    MAIN_SelChange_BANK(5, ID_COMBO_START_SECOND);
    MAIN_SelChange_BANK(6, ID_COMBO_STOP_YEAR);
    MAIN_SelChange_BANK(7, ID_COMBO_STOP_MONTH);
    MAIN_SelChange_BANK(8, ID_COMBO_STOP_DAY);
    MAIN_SelChange_BANK(9, ID_COMBO_STOP_HOUR);
    MAIN_SelChange_BANK(10, ID_COMBO_STOP_MINUTE);
    MAIN_SelChange_BANK(11, ID_COMBO_STOP_SECOND);
    MAIN_SelChange_BANK(12, ID_COMBO_CHANNEL);
    MAIN_SelChange_BANK(13, ID_EDIT_FILENAME);
}


/*
 *
 */
void MAIN_Show(HWND hWnd)
{
    NOTIFYICONDATA nid;

    /* ^XNgCACR폜 */
    nid.cbSize = sizeof(NOTIFYICONDATA);
    nid.hWnd   = hWnd;
    nid.uID    = 0;
    nid.uFlags = 0;
    Shell_NotifyIcon(NIM_DELETE, &nid);
    /* _CAO\ */
    ShowWindow(hWnd, SW_SHOW);
}


/*
 *
 */
void MAIN_Hide(HWND hWnd)
{
    NOTIFYICONDATA nid;

    /* _CAOB */
    ShowWindow(hWnd, SW_HIDE);
    /* ^XNgCACRǉ */
    nid.cbSize           = sizeof(NOTIFYICONDATA);
    nid.hWnd             = hWnd;
    nid.uID              = 0;
    nid.uFlags           = NIF_MESSAGE | NIF_ICON | NIF_TIP;
    nid.uCallbackMessage = WM_USER + 1;
    nid.hIcon            = LoadIcon(RESOURCE, "ICON");
    StrCpy(nid.szTip, TITLE);
    Shell_NotifyIcon(NIM_ADD, &nid);
}


/*
 * ^C}
 */
void MAIN_Timer(HWND hWnd)
{
    SYSTEMTIME  st;
    long        nIndex;
    long        wDay;
    long        wHour;
    long        wMonth;
    long        wYear;
    long        xFrac;
    long        xTime;
    long        yFrac;
    long        yTime;
    static BOOL bBusy = FALSE;

    if (bBusy) {
        return;
    }
    bBusy = TRUE;
    GetLocalTime(&st);
    /* ݎ */
    wYear   = st.wYear;
    wMonth  = st.wMonth;
    wDay    = st.wDay;
    wHour   = st.wHour;
    xTime   = st.wMinute;
    xFrac   = st.wSecond;
    wMonth += wYear * 12;
    wDay   += wMonth * 31;
    wHour  += wDay * 24;
    xTime  += wHour * 60;
    /* A[ */
    yTime = gAlarmTime;
    yFrac = gAlarmFrac;
    if ((xTime > yTime) || ((xTime == yTime) && (xFrac >= yFrac))) {
        MAIN_Update(hWnd);
    }
    bBusy = FALSE;
}


/*
 * hbv
 */
void MAIN_DropFiles(HWND hWnd, HDROP hDrop)
{
    char *lpFoot;
    char *lpHead;
    char chr;
    char szCmdLine[1024];
    char szExecName[1024];
    char szFileName[1024];
    long nCount;
    long nIndex;

    /* st@CpX */
    GetModuleFileName(0, szExecName, sizeof(szExecName));
    lpHead = lpFoot = szExecName;
    chr    = *lpFoot;
    while (chr) {
        if (chr == '\\') {
            lpHead = lpFoot + 1;
        }
        lpFoot = CharNext(lpFoot);
        chr    = *lpFoot;
    }
    wsprintf(lpHead, "nnc4hdus.exe");
    /* */
    nCount = DragQueryFile(hDrop, 0xFFFFFFFF, 0, 0);
    for (nIndex = 0; nIndex < nCount; nIndex++) {
        DragQueryFile(hDrop, nIndex, szFileName, sizeof(szFileName));
        wsprintf(szCmdLine, "\"%s\" -o \"%s\"", szExecName, szFileName);
        MAIN_Log(hWnd, szCmdLine);
        ExecuteProcess(szCmdLine, TRUE, TRUE);
    }
}


/*
 * I
 */
void MAIN_Close(HWND hWnd)
{
    long nIndex;

    /* ^C}~ */
    KillTimer(hWnd, 0);
    /* ^撆̈Č~ */
    if (gRecord) {
        for (nIndex = 0; nIndex < MAX_UNIT_COUNT; nIndex++) {
            if (gDevice[nIndex]) {
                HDUS_Close(gDevice[nIndex]);
                HDUS_Delete(gDevice[nIndex]);
            }
        }
    }
    /* ݒ̃Z[u */
    MAIN_SaveINI(hWnd);
    /* _CAO̕\(^XNgCACR̍폜) */
    MAIN_Show(hWnd);
    /* EBhE̊J */
    DestroyWindow(hWnd);
}


/*
 * I
 */
void MAIN_BeforeClose(HWND hWnd)
{
    char szText[256];

    LoadString(RESOURCE, ID_STR_CLOSE, szText, sizeof(szText));
    if (MessageBox(hWnd, szText, TITLE, MB_YESNOCANCEL | MB_ICONQUESTION) == IDYES) {
        MAIN_Close(hWnd);
    }
}


/*
 * 
 */
void MAIN_LoadList(HWND hWnd)
{
    HANDLE hFile;
    HWND   hItem;
    char   *lpFoot;
    char   *lpHead;
    char   chr;
    char   szText[1024];

    hItem = GetDlgItem(hWnd, ID_COMBO_CHANNEL);
    GetModuleFileName(0, szText, sizeof(szText));
    lpHead = lpFoot = szText;
    chr    = *lpFoot;
    while (chr) {
        if (chr == '\\') {
            lpHead = lpFoot + 1;
        }
        lpFoot = CharNext(lpFoot);
        chr    = *lpFoot;
    }
    wsprintf(lpHead, "CHANNEL.TXT");
    hFile = OpenFileR(szText);
    while (ReadFileLine(hFile, szText, sizeof(szText))) {
        SendMessage(hItem, CB_ADDSTRING, 0, (LPARAM) szText);
    }
    CloseHandle(hFile);
}


/*
 * R{{bNX̏lݒ
 */
void MAIN_InitCombo(HWND hWnd, DWORD dwID, long nStart, long nEnd, long nStep, char *lpFormat)
{
    HWND hItem;
    char szText[256];
    long nIndex;

    hItem = GetDlgItem(hWnd, dwID);
    for (nIndex = nStart; nIndex <= nEnd; nIndex += nStep) {
        wsprintf(szText, lpFormat, nIndex);
        SendMessage(hItem, CB_ADDSTRING, 0, (LPARAM) szText);
    }
    SendMessage(hItem, CB_SETCURSEL, 0, 0);
}


/*
 * 
 */
void MAIN_InitDialog(HWND hWnd)
{
    SYSTEMTIME st;
    char       szText[1024];
    long       nIndex;

    /* ^Cg̕ۑ */
    GetWindowText(hWnd, TITLE, sizeof(TITLE));
    /* O[oϐ̏ */
    gRecord = 0;
    for (nIndex = 0; nIndex < MAX_UNIT_COUNT; nIndex++) {
        gDevice[nIndex] = 0;
    }
    /* ACR */
    SendMessage(hWnd, WM_SETICON, ICON_BIG, (LPARAM) LoadIcon(RESOURCE, "ICON"));
    /* EBhȄ */
    SetWindowPos(hWnd, HWND_NOTOPMOST, 0, 0, 0, 0, SWP_NOMOVE | SWP_NOSIZE);
    /* `lXg */
    MAIN_LoadList(hWnd);
    /* R{\ */
    MAIN_InitCombo(hWnd, ID_COMBO_START_YEAR, 2008, 2099, 1, "%d");
    MAIN_InitCombo(hWnd, ID_COMBO_START_MONTH, 1, 12, 1, "%02d");
    MAIN_InitCombo(hWnd, ID_COMBO_START_DAY, 1, 31, 1, "%02d");
    MAIN_InitCombo(hWnd, ID_COMBO_START_HOUR, 0, 23, 1, "%02d");
    MAIN_InitCombo(hWnd, ID_COMBO_START_MINUTE, 0, 59, 1, "%02d");
    MAIN_InitCombo(hWnd, ID_COMBO_START_SECOND, 0, 59, 1, "%02d");
    MAIN_InitCombo(hWnd, ID_COMBO_STOP_YEAR, 2008, 2099, 1, "%d");
    MAIN_InitCombo(hWnd, ID_COMBO_STOP_MONTH, 1, 12, 1, "%02d");
    MAIN_InitCombo(hWnd, ID_COMBO_STOP_DAY, 1, 31, 1, "%02d");
    MAIN_InitCombo(hWnd, ID_COMBO_STOP_HOUR, 0, 23, 1, "%02d");
    MAIN_InitCombo(hWnd, ID_COMBO_STOP_MINUTE, 0, 59, 1, "%02d");
    MAIN_InitCombo(hWnd, ID_COMBO_STOP_SECOND, 0, 59, 1, "%02d");
    MAIN_InitCombo(hWnd, ID_COMBO_CHANNEL, 13, 62, 1, "@%02d");
    MAIN_InitCombo(hWnd, ID_COMBO_CHANNEL, 36, 63, 1, "@C%02d");
    /* ݎ𔽉f */
    GetLocalTime(&st);
    wsprintf(szText, "%d", st.wYear);
    SetDlgItemText(hWnd, ID_COMBO_START_YEAR, szText);
    SetDlgItemText(hWnd, ID_COMBO_STOP_YEAR, szText);
    wsprintf(szText, "%02d", st.wMonth);
    SetDlgItemText(hWnd, ID_COMBO_START_MONTH, szText);
    SetDlgItemText(hWnd, ID_COMBO_STOP_MONTH, szText);
    wsprintf(szText, "%02d", st.wDay);
    SetDlgItemText(hWnd, ID_COMBO_START_DAY, szText);
    SetDlgItemText(hWnd, ID_COMBO_STOP_DAY, szText);
    wsprintf(szText, "%02d", st.wHour);
    SetDlgItemText(hWnd, ID_COMBO_START_HOUR, szText);
    SetDlgItemText(hWnd, ID_COMBO_STOP_HOUR, szText);
    wsprintf(szText, "%02d", st.wMinute);
    SetDlgItemText(hWnd, ID_COMBO_START_MINUTE, szText);
    SetDlgItemText(hWnd, ID_COMBO_STOP_MINUTE, szText);
    wsprintf(szText, "%02d", st.wSecond);
    SetDlgItemText(hWnd, ID_COMBO_START_SECOND, szText);
    SetDlgItemText(hWnd, ID_COMBO_STOP_SECOND, szText);
    /* _CAOB */
    MAIN_Hide(hWnd);
    /* ݒ̃[h */
    MAIN_LoadINI(hWnd);
    /* A[̍XV */
    MAIN_Alarm(hWnd);
    /* ^C}[̓o^ */
    SetTimer(hWnd, 0, 1000, 0);
    /* hbv̋ */
    DragAcceptFiles(hWnd, TRUE);
}


/*
 * Cxg֐
 */
LRESULT CALLBACK MAIN_Event(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg) {
    case WM_COMMAND:
        switch (LOWORD(wParam)) {
        case ID_BUTTON_REFER:
            MAIN_Refer(hWnd);
            break;
        case ID_BUTTON_ADD:
            MAIN_Add(hWnd);
            break;
        case ID_BUTTON_DELETE:
            MAIN_Delete(hWnd);
            break;
        case ID_BUTTON_CLOSE:
            MAIN_Close(hWnd);
            break;
        case ID_LIST_SCHEDULE:
            if (HIWORD(wParam) == LBN_SELCHANGE) {
                MAIN_SelChange(hWnd, LOWORD(wParam));
            }
            break;
        }
        break;
    case WM_USER + 1:
        if (lParam == WM_LBUTTONDOWN) {
            MAIN_Show(hWnd);
        }
        else if (lParam == WM_RBUTTONDOWN) {
            MAIN_BeforeClose(hWnd);
        }
        break;
    case WM_SYSCOMMAND:
        if (wParam == SC_MINIMIZE) {
            MAIN_Hide(hWnd);
            return(TRUE);
        }
        break;
    case WM_DROPFILES:
        MAIN_DropFiles(hWnd, (HDROP) wParam);
        break;
    case WM_TIMER:
        MAIN_Timer(hWnd);
        break;
    case WM_CLOSE:
        MAIN_Close(hWnd);
        break;
    case WM_DESTROY:
        PostQuitMessage(0);
        break;
    case WM_INITDIALOG:
        MAIN_InitDialog(hWnd);
        break;
    }
    return(FALSE);
}


/*
 * Gg[
 */
int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    HWND hWnd;
    MSG  msg;

    RESOURCE = hInstance;
    InitLog(); /* O */
    hWnd = CreateDialog(hInstance, "MAIN", NULL, (DLGPROC) MAIN_Event);
    ShowWindow(hWnd, SW_HIDE);
    UpdateWindow(hWnd);
    while (GetMessage(&msg, NULL, 0, 0)) {
        TranslateMessage(&msg);
        DispatchMessage(&msg);
    }
    FreeLog(); /* O */
    return(msg.wParam);
}
